const
  no     = 0;    im8    = 1;    im16   = 2;    im32   = 3;    of8    = 4;
  of16   = 5;    r8     = 6;    r16    = 7;    rm8    = 8;    rm16   = 9;
  rSEG   = 10;   m8     = 11;   m16    = 12;   m32    = 13;   rAL    = 14;
  rCL    = 15;   rDL    = 16;   rBL    = 17;   rAH    = 18;   rCH    = 19;
  rDH    = 20;   rBH    = 21;   rAX    = 22;   rCX    = 23;   rDX    = 24;
  rBX    = 25;   rSP    = 26;   rBP    = 27;   rSI    = 28;   rDI    = 29;
  sES    = 30;   sCS    = 31;   sSS    = 32;   sDS    = 33;   sFS    = 34;
  sGS    = 35;   arop1  = 36;   arop2  = 37;   sftop  = 38;   grp1   = 39;
  grp2   = 40;   grp3   = 41;   esc0   = 42;   esc1   = 43;   esc2   = 44;
  esc3   = 45;   esc4   = 46;   esc5   = 47;   esc6   = 48;   esc7   = 49;
  short  = 50;   near   = 51;   far    = 52;   zpt    = 53;   dwt    = 54;
  cmt    = 55;   num1   = 56;   num3   = 57;
  {}
  bytep  = 'byte ptr ';
  wordp  = 'word ptr ';
  dwordp = 'dword ptr ';
  qwordp = 'qword ptr ';
var
  f     : file;
  buf   : array[0..1024*55-1] of byte;
  a     : array[0..255] of string[10]; {ࠧ }
  b     : array[0..47] of string[10];  {  権}
  m     : array[0..150] of string[10]; { .ᮯ}
  regs  : array[0..15] of string[2];   {ॣ}
  segs  : array[0..5] of string[2];    {ᥣ ॣ}
  str   : string;                      {ப ।⠢ }
  size  : integer;                     {ࠧ  }
  ofs,ip: integer;                     {  , 砫 }
  addr  : integer;
  i, n  : word;
  pseg  : byte;
  p66h  : boolean;
  p67h  : boolean;


function hexByte(b : byte) : string;
{  hex-ப}
const
  h : array[0..15] of char = '0123456789ABCDEF';
begin
  hexByte := h[b shr 4] + h[b and $F];
end;


function hexWord(w : word) : string;
{᫮  hex-ப}
begin
  hexWord := hexByte(Hi(w))+hexByte(Lo(w));
end;


function getByte : byte;
{  asm-}
begin
  getByte := buf[ip];
  inc(ip);
end;


function getWord : word;
{᫮  asm-}
begin
  getWord := $100*getByte + getByte;
end;


procedure check66h;
{ ᫨ ᨬ ७ ॣ}
begin
  if p66h then  str := str + 'E';
end;


procedure checkSeg;
{ ᫨ ,   DS}
begin
  if pseg <> sDS then
  begin
    check66h;
    str := str + segs[pseg-sES] + ':';
    pseg := sDS;
  end;
end;


procedure addrMode(b : Byte);
{ ० 樨 }
begin
  checkSeg;
  str := str + '[';
  if p67h = false then
    case (b and $07) of
     0 : str := str + 'BX+SI';
     1 : str := str + 'BX+DI';
     2 : str := str + 'BP+SI';
     3 : str := str + 'BP+DI';
     4 : str := str + 'SI';
     5 : str := str + 'DI';
     6 : if (b and $c0) = 0 then  str := str+HexWord(GetWord)+'h'  {ᬥ饭}
           else  str := str + 'BP';
     7 : str := str + 'BX';
    end
  else
    case (b and $07) of
     0 : str := str + 'EBX+ESI';
     1 : str := str + 'EBX+EDI';
     2 : str := str + 'EBP+ESI';
     3 : str := str + 'EBP+EDI';
     4 : str := str + 'ESI';
     5 : str := str + 'EDI';
     6 : if (b and $c0) = 0 then  str := str+HexWord(GetWord)+'h'  {ᬥ饭}
           else  str := str + 'EBP';
     7 : str := str + 'EBX';
    end;
  {--}
  case (b and $c0) of
   $40 : str := str + '+'+hexByte(getByte)+'h';   {ᬥ饭 1 }
   $80 : str := str + '+'+hexWord(getWord)+'h';   {ᬥ饭 2 }
  end;
  str := str + ']';
end;


procedure disAsm;
{ᥬ஢   ப str}
var
  byte1,byte2 : byte;            {1-,2-  設 }
  _ip : byte;                    {- ⠭    }
  c : byte;
begin
  p66h := false;
  p67h := false;
  pseg := sDS;
  repeat
    byte1 := getByte;            {   }
    case byte1 of
     $66 : p66h := true;
     $67 : p67h := true;
     $26 : pseg := sES;
     $2E : pseg := sCS;
     $36 : pseg := sSS;
     $3E : pseg := sDS;
     $64 : pseg := sFS;
     $65 : pseg := sGS;
     else break;
    end;
  until false;
  _ip:=ip;   {᪮쪮  ⥭  砫   䨪ᮢ}
  str:=copy(a[byte1],5,10)+#9;  { }
  for i:=0 to 3 do
  begin
    c:=ord(a[byte1][i+1]);
    case c of
     no       : begin end;                     { }
     rAL..rDI : begin
                  check66h;
                  str := str + regs[c-rAL];    {ॣ}
                end;
     sES..sGS : begin
                  check66h;
                  str := str + segs[c-sES];    {ᥣ ॣ}
                end;
     short    : str := str + 'short';          {⪨}
     near     : str := str + 'near';           {}
     far      : str := str + 'far';            {쭨}
     zpt      : str := str + ',';              {}
     cmt      : str := str + #9#9'; ';         {ᨬ }
     dwt      : str := str + ':';              {稥}
     num1     : str := str + '1'#9#9'; 88x86'; {"1"}
     num3     : str := str + '3';              {"3"}
     esc0..esc7:begin    { .ᮯ}
                  n := getByte+getByte;
                end;
     arop1..grp3:begin   {  樨...ࠧ }
                  byte2 := getByte;
                  n  := (c-arop1)*8+ { ப b  ﬨ}
                        (byte2 shr 3) and 7;   { 5..3-   樨}
                  str := b[n]+#9;              {  ⠡  }
                  if (n = 24) then             {test rm8_16<>,im8_16}
                  begin
                    case ord(a[byte1][2]) of
                     rm8  : a[byte1][4] := chr(im8);
                     rm16 : a[byte1][4] := chr(im16);
                    end;
                    a[byte1][3] := chr(zpt);
                  end;
                end;
     im8      : str := str + hexByte(getByte)+'h';
     im16     : str := str + hexWord(getWord)+'h';
     of8      : begin
                  addr := getByte;
                  if (addr and $80) = 0 then  addr := ip+addr
                    else  addr := addr+ip-$FF-1;
                  str := str + hexWord(addr)+':';
                end;
     of16     : begin
                  addr := getWord;
                  if (addr and $8000) = 0 then addr := ip+addr
                    else  addr := addr+ip-$FFFF-1;
                  str := str + hexWord(addr)+':';
                end;
     m8,m16   : begin
                  if c = m8 then  str := str + bytep
                    else  str := str + wordp;
                  checkSeg;
                  str := str +'['+ hexWord(getWord)+'h]';
                end;
     im32     : begin         { DWord ᫮ ᯮ  ।}
                  n := getWord;
                  str := str + hexWord(getWord)+hexWord(n)+'h';
                end;
     r8       : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  str := str + regs[(byte2 shr 3) and 7];   {ॣ 8bit}
                end;
     r16      : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  check66h;
                  str := str + regs[((byte2 shr 3) and 7)+8]; {ॣ 16bit}
                end;
     rSEG     : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  check66h;
                  str := str + segs[(byte2 shr 3) and 7];   {ᥣ ॣ}
                end;
     rm8      : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  if (byte2 and $c0)=$c0 then  str := str + regs[byte2 and $07] {ॣ 8bit}
                  else
                  begin
                    str := str + bytep;
                    addrMode(byte2);
                  end;
                end;
     rm16     : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  if (byte2 and $c0)=$c0 then
                  begin
                    check66h;
                    str := str + regs[(byte2 and $07)+8]; {ॣ 16b}
                  end
                  else
                  begin
                    str := str + wordp;
                    addrMode(byte2);
                  end;
                end;
     m32      : begin
                  if ip=_ip then  byte2 := getByte; {  ᯮᮡ 樨}
                  str := str + dwordp;
                  addrMode(byte2);
                end;
    end;
    if str=#9 then begin str:='DB'#9 + hexByte(byte1); break; end; {⭠ }
    if str='EXTOP'#9 then begin n:=getByte+getByte+getByte; break; end; {FXSTOR m / FXSAVE m}
  end;
  checkSeg;
end;


begin
  a[$00]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'ADD';
  a[$01]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'ADD';
  a[$02]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'ADD';
  a[$03]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'ADD';
  a[$04]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'ADD';
  a[$05]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'ADD';
  a[$06]:=chr(sES    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';  {  ⭠}
  a[$07]:=chr(sES    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$08]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'OR';
  a[$09]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'OR';
  a[$0A]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'OR';
  a[$0B]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'OR';
  a[$0C]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'OR';
  a[$0D]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'OR';
  a[$0E]:=chr(sCS    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$0F]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'EXTOP';
  a[$10]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'ADC';
  a[$11]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'ADC';
  a[$12]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'ADC';
  a[$13]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'ADC';
  a[$14]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'ADC';
  a[$15]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'ADC';
  a[$16]:=chr(sSS    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$17]:=chr(sSS    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$18]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'SBB';
  a[$19]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'SBB';
  a[$1A]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'SBB';
  a[$1B]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'SBB';
  a[$1C]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'SBB';
  a[$1D]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'SBB';
  a[$1E]:=chr(sDS    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$1F]:=chr(sDS    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$20]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'AND';
  a[$21]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'AND';
  a[$22]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'AND';
  a[$23]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'AND';
  a[$24]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'AND';
  a[$25]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'AND';
  a[$26]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'ES';
  a[$27]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'DAA';
  a[$28]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'SUB';
  a[$29]:=chr(rm16   )+chr(no     )+chr(r16    )+chr(no     )+'SUB';
  a[$2A]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'SUB';
  a[$2B]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'SUB';
  a[$2C]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'SUB';
  a[$2D]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'SUB';
  a[$2E]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'CS';
  a[$2F]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'DAS';
  a[$30]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'XOR';
  a[$31]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'XOR';
  a[$32]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'XOR';
  a[$33]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'XOR';
  a[$34]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'XOR';
  a[$35]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'XOR';
  a[$36]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'SS';
  a[$37]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'AAA';
  a[$38]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'CMP';
  a[$39]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'CMP';
  a[$3A]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'CMP';
  a[$3B]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'CMP';
  a[$3C]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'CMP';
  a[$3D]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'CMP';
  a[$3E]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'DS';
  a[$3F]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'AAS';
  a[$40]:=chr(rAX    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$41]:=chr(rCX    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$42]:=chr(rDX    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$43]:=chr(rBX    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$44]:=chr(rSP    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$45]:=chr(rBP    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$46]:=chr(rSI    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$47]:=chr(rDI    )+chr(no     )+chr(no     )+chr(no     )+'INC';
  a[$48]:=chr(rAX    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$49]:=chr(rCX    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4A]:=chr(rDX    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4B]:=chr(rBX    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4C]:=chr(rSP    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4D]:=chr(rBP    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4E]:=chr(rSI    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$4F]:=chr(rDI    )+chr(no     )+chr(no     )+chr(no     )+'DEC';
  a[$50]:=chr(rAX    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$51]:=chr(rCX    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$52]:=chr(rDX    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$53]:=chr(rBX    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$54]:=chr(rSP    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$55]:=chr(rBP    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$56]:=chr(rSI    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$57]:=chr(rDI    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';
  a[$58]:=chr(rAX    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$59]:=chr(rCX    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5A]:=chr(rDX    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5B]:=chr(rBX    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5C]:=chr(rSP    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5D]:=chr(rBP    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5E]:=chr(rSI    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$5F]:=chr(rDI    )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$60]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'PUSHA';  {*pusha}
  a[$61]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'POPA';   {*popa}
  a[$62]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'BOUND';  {*bound}
  a[$63]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'ARPL';   {arpl}
  a[$64]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'FS';     {**seg fs}
  a[$65]:=chr(dwt    )+chr(no     )+chr(no     )+chr(no     )+'GS';     {**seg gs}
  a[$66]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'';       {**opsize prefix}
  a[$67]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'';       {**addrsize prefix}
  a[$68]:=chr(im16   )+chr(no     )+chr(no     )+chr(no     )+'PUSH';   {*push im16}
  a[$69]:=chr(rm16   )+chr(zpt    )+chr(im16   )+chr(no     )+'IMUL';   {*imul r/m,im16}
  a[$6A]:=chr(im8    )+chr(no     )+chr(no     )+chr(no     )+'PUSH';   {*push im8}
  a[$6B]:=chr(rm8    )+chr(zpt    )+chr(im8    )+chr(no     )+'IMUL';   {*imul r/m,im8}
  a[$6C]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'INSB';   {*insb}
  a[$6D]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'INSW';   {*insw}
  a[$6E]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'OUTSB';  {*outsb}
  a[$6F]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'OUTSW';  {*outsw}
  a[$70]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JO';
  a[$71]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JNO';
  a[$72]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JB';
  a[$73]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JNB';
  a[$74]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JZ';
  a[$75]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JNZ';
  a[$76]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JBE';
  a[$77]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JA';
  a[$78]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JS';
  a[$79]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JNS';
  a[$7A]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JPE';
  a[$7B]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JPO';
  a[$7C]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JL';
  a[$7D]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JGE';
  a[$7E]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JLE';
  a[$7F]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JG';
  a[$80]:=chr(arop1  )+chr(rm8    )+chr(zpt    )+chr(im8    )+'';
  a[$81]:=chr(arop1  )+chr(rm16   )+chr(zpt    )+chr(im16   )+'';       {word ptr}
  a[$82]:=chr(arop2  )+chr(rm8    )+chr(zpt    )+chr(im8    )+'';       {byte ptr}
  a[$83]:=chr(arop1  )+chr(rm16   )+chr(zpt    )+chr(im8    )+'';
  a[$84]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'TEST';
  a[$85]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'TEST';
  a[$86]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'XCHG';   { ;) }
  a[$87]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'XCHG';   { ;) }
  a[$88]:=chr(rm8    )+chr(zpt    )+chr(r8     )+chr(no     )+'MOV';
  a[$89]:=chr(rm16   )+chr(zpt    )+chr(r16    )+chr(no     )+'MOV';
  a[$8A]:=chr(r8     )+chr(zpt    )+chr(rm8    )+chr(no     )+'MOV';
  a[$8B]:=chr(r16    )+chr(zpt    )+chr(rm16   )+chr(no     )+'MOV';
  a[$8C]:=chr(rm16   )+chr(zpt    )+chr(rSEG   )+chr(no     )+'MOV';
  a[$8D]:=chr(r16    )+chr(zpt    )+chr(m32    )+chr(no     )+'LEA';
  a[$8E]:=chr(rSEG   )+chr(zpt    )+chr(rm16   )+chr(no     )+'MOV';
  a[$8F]:=chr(rm16   )+chr(no     )+chr(no     )+chr(no     )+'POP';
  a[$90]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'NOP';
  a[$91]:=chr(rAX    )+chr(zpt    )+chr(rCX    )+chr(no     )+'XCHG';
  a[$92]:=chr(rAX    )+chr(zpt    )+chr(rDX    )+chr(no     )+'XCHG';
  a[$93]:=chr(rAX    )+chr(zpt    )+chr(rBX    )+chr(no     )+'XCHG';
  a[$94]:=chr(rAX    )+chr(zpt    )+chr(rSP    )+chr(no     )+'XCHG';
  a[$95]:=chr(rAX    )+chr(zpt    )+chr(rBP    )+chr(no     )+'XCHG';
  a[$96]:=chr(rAX    )+chr(zpt    )+chr(rSI    )+chr(no     )+'XCHG';
  a[$97]:=chr(rAX    )+chr(zpt    )+chr(rDI    )+chr(no     )+'XCHG';
  a[$98]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CBW';
  a[$99]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CWD';
  a[$9A]:=chr(im32   )+chr(cmt    )+chr(far    )+chr(no     )+'CALL';   {9090:9090 - call far}
  a[$9B]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'FWAIT';
  a[$9C]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'PUSHF';
  a[$9D]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'POPF';
  a[$9E]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'SAHF';
  a[$9F]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'LAHF';
  a[$A0]:=chr(rAL    )+chr(zpt    )+chr(m8     )+chr(no     )+'MOV';
  a[$A1]:=chr(rAX    )+chr(zpt    )+chr(m16    )+chr(no     )+'MOV';
  a[$A2]:=chr(m8     )+chr(zpt    )+chr(rAL    )+chr(no     )+'MOV';
  a[$A3]:=chr(m16    )+chr(zpt    )+chr(rAX    )+chr(no     )+'MOV';
  a[$A4]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'MOVSB';
  a[$A5]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'MOVSW';
  a[$A6]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CMPSB';
  a[$A7]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CMPSW';
  a[$A8]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'TEST';     {mem8  90}
  a[$A9]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'TEST';     {mem16  9090}
  a[$AA]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'STOSB';
  a[$AB]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'STOSW';
  a[$AC]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'LODSB';
  a[$AD]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'LODSW';
  a[$AE]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'SCASB';
  a[$AF]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'SCASW';
  a[$B0]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B1]:=chr(rCL    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B2]:=chr(rDL    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B3]:=chr(rBL    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B4]:=chr(rAH    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B5]:=chr(rCH    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B6]:=chr(rDH    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B7]:=chr(rBH    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$B8]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$B9]:=chr(rCX    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BA]:=chr(rDX    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BB]:=chr(rBX    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BC]:=chr(rSP    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BD]:=chr(rBP    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BE]:=chr(rSI    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$BF]:=chr(rDI    )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$C0]:=chr(sftop  )+chr(rm8    )+chr(zpt    )+chr(im8    )+'';       {*sftop r/m,im8}
  a[$C1]:=chr(sftop  )+chr(rm16   )+chr(zpt    )+chr(im8    )+'';       {*sftop r/m,im16}
  a[$C2]:=chr(im16   )+chr(cmt    )+chr(near   )+chr(no     )+'RET';
  a[$C3]:=chr(cmt    )+chr(near   )+chr(no     )+chr(no     )+'RET';
  a[$C4]:=chr(r16    )+chr(zpt    )+chr(m32    )+chr(no     )+'LES';
  a[$C5]:=chr(r16    )+chr(zpt    )+chr(m32    )+chr(no     )+'LDS';
  a[$C6]:=chr(rm8    )+chr(zpt    )+chr(im8    )+chr(no     )+'MOV';
  a[$C7]:=chr(rm16   )+chr(zpt    )+chr(im16   )+chr(no     )+'MOV';
  a[$C8]:=chr(im16   )+chr(im8    )+chr(no     )+chr(no     )+'ENTER';  {*enter im16,im8}
  a[$C9]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'LEAVE';  {*leave}
  a[$CA]:=chr(im16   )+chr(cmt    )+chr(far    )+chr(no     )+'RETF';
  a[$CB]:=chr(cmt    )+chr(far    )+chr(no     )+chr(no     )+'RETF';
  a[$CC]:=chr(num3   )+chr(no     )+chr(no     )+chr(no     )+'INT';
  a[$CD]:=chr(im8    )+chr(no     )+chr(no     )+chr(no     )+'INT';
  a[$CE]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'INTO';
  a[$CF]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'IRET';
  a[$D0]:=chr(sftop  )+chr(rm8    )+chr(zpt    )+chr(num1   )+'';
  a[$D1]:=chr(sftop  )+chr(rm16   )+chr(zpt    )+chr(num1   )+'';
  a[$D2]:=chr(sftop  )+chr(rm8    )+chr(zpt    )+chr(rCL    )+'';
  a[$D3]:=chr(sftop  )+chr(rm16   )+chr(zpt    )+chr(rCL    )+'';
  a[$D4]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'AAM';
  a[$D5]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'AAD';
  a[$D6]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'';       {?}
  a[$D7]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'XLAT';
  a[$D8]:=chr(esc0   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$D9]:=chr(esc1   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DA]:=chr(esc2   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DB]:=chr(esc3   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DC]:=chr(esc4   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DD]:=chr(esc5   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DE]:=chr(esc6   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$DF]:=chr(esc7   )+chr(no     )+chr(no     )+chr(no     )+'ESC';
  a[$E0]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'LOOPNZ';
  a[$E1]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'LOOPZ';
  a[$E2]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'LOOP';
  a[$E3]:=chr(of8    )+chr(no     )+chr(no     )+chr(no     )+'JCXZ';
  a[$E4]:=chr(rAL    )+chr(zpt    )+chr(im8    )+chr(no     )+'IN';
  a[$E5]:=chr(rAX    )+chr(zpt    )+chr(im16   )+chr(no     )+'IN';
  a[$E6]:=chr(im8    )+chr(zpt    )+chr(rAL    )+chr(no     )+'OUT';
  a[$E7]:=chr(im16   )+chr(zpt    )+chr(rAX    )+chr(no     )+'OUT';
  a[$E8]:=chr(of16   )+chr(cmt    )+chr(near   )+chr(no     )+'CALL';  {961B}
  a[$E9]:=chr(of16   )+chr(cmt    )+chr(near   )+chr(no     )+'JMP';   {9620}
  a[$EA]:=chr(m32    )+chr(cmt    )+chr(far    )+chr(no     )+'JMP';   {9090:9090}
  a[$EB]:=chr(of8    )+chr(cmt    )+chr(short  )+chr(no     )+'JMP';   {0529}
  a[$EC]:=chr(rAL    )+chr(zpt    )+chr(rDX    )+chr(no     )+'IN';
  a[$ED]:=chr(rAX    )+chr(zpt    )+chr(rDX    )+chr(no     )+'IN';
  a[$EE]:=chr(rDX    )+chr(zpt    )+chr(rAL    )+chr(no     )+'OUT';
  a[$EF]:=chr(rDX    )+chr(zpt    )+chr(rAX    )+chr(no     )+'OUT';
  a[$F0]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'LOCK';
  a[$F1]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'';      {?}
  a[$F2]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'REP';
  a[$F3]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'REPZ';
  a[$F4]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'HLT';
  a[$F5]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CMC';
  a[$F6]:=chr(grp1   )+chr(rm8    )+chr(no     )+chr(no     )+'';
  a[$F7]:=chr(grp1   )+chr(rm16   )+chr(no     )+chr(no     )+'';
  a[$F8]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CLC';
  a[$F9]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'STC';
  a[$FA]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CLI';
  a[$FB]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'STI';
  a[$FC]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'CLD';
  a[$FD]:=chr(no     )+chr(no     )+chr(no     )+chr(no     )+'STD';
  a[$FE]:=chr(grp2   )+chr(rm8    )+chr(no     )+chr(no     )+'';
  a[$FF]:=chr(grp3   )+chr(rm16   )+chr(no     )+chr(no     )+'';
  {-------}
  b[0]:='ADD';  b[1]:='OR';  b[2]:='ADC';   b[3]:='SBB';   b[4]:='AND';  b[5]:='SUB';  b[6]:='XOR';  b[7]:='CMP';  {arop1}
  b[8]:='ADD';  b[9]:='';    b[10]:='';     b[11]:='';     b[12]:='';    b[13]:='SUB'; b[14]:='';    b[15]:='CMP'; {arop2}
  b[16]:='ROL'; b[17]:='ROR';b[18]:='RCL';  b[19]:='RCR';  b[20]:='SHL'; b[21]:='SHR'; b[22]:='';    b[23]:='SAR'; {sftop}
  b[24]:='TEST';b[25]:='';   b[26]:='NOT';  b[27]:='NEG';  b[28]:='MUL'; b[29]:='IMUL';b[30]:='DIV'; b[31]:='IDIV';{grp1}
  b[32]:='INC'; b[33]:='DEC';b[34]:='CALLn';b[35]:='CALLf';b[36]:='';    b[37]:='';    b[38]:='';    b[39]:='';    {grp2}
  b[40]:='INC'; b[41]:='DEC';b[42]:='CALLn';b[43]:='CALLf';b[44]:='JMPn';b[45]:='JMPf';b[46]:='PUSH';b[47]:='';    {grp3}
  {-------}
  regs[0]:='AL';  regs[1]:='CL';  regs[2]:='DL';  regs[3]:='BL';
  regs[4]:='AH';  regs[5]:='CH';  regs[6]:='DH';  regs[7]:='BH';
  regs[8]:='AX';  regs[9]:='CX';  regs[10]:='DX'; regs[11]:='BX';
  regs[12]:='SP'; regs[13]:='BP'; regs[14]:='SI'; regs[15]:='DI';
  {-------}
  segs[0]:='ES';  segs[1]:='CS';  segs[2]:='SS';  segs[3]:='DS';
  segs[4]:='FS';  segs[5]:='GS';
  {-------}
  {_$d8}
  m[0]:='FADD m32';
  m[1]:='FADD st(0),st(i)';
  m[2]:='FCOM m32';
  m[3]:='FCOM st(i)';
  m[4]:='FCOMP m32';
  m[5]:='FCOMP st(i)';
  m[6]:='FDIV m32';
  m[7]:='FDIV st(0),st(i)';
  m[8]:='FDIVR m32';
  m[9]:='FDIVR st(0),st(i)';
  m[10]:='FMUL m32';
  m[11]:='FMUL st(0),st(i)';
  m[12]:='FSUB m32';
  m[13]:='FSUB st(0),st(i)';
  m[14]:='FSUBR m32';
  m[15]:='FSUBR st(0),st(i)';
  {_$d9}
  m[16]:='F2XM1';
  m[17]:='FABS';
  m[18]:='FCHS';
  m[19]:='FCOS';
  m[20]:='FDECSTP';
  m[21]:='FINCSTP';
  m[22]:='FLD m32';
  m[23]:='FLD st(i)';
  m[24]:='FLD1';
  m[25]:='FLDL2T';
  m[26]:='FLDL2E';
  m[27]:='FLDPI';
  m[28]:='FLDLG2';
  m[29]:='FLDLN2';
  m[30]:='FLDZ';
  m[31]:='FLDCW m16';
  m[32]:='FLDENV m14';
  m[33]:='FNOP';
  m[34]:='FNSTCW m16';
  m[35]:='FNSTENV m';
  m[36]:='FPATAN';
  m[37]:='FPREM';
  m[38]:='FPREM1';
  m[39]:='FPTAN';
  m[40]:='FRNDINT';
  m[41]:='FSCALE';
  m[42]:='FSIN';
  m[43]:='FSINCOS';
  m[44]:='FSQRT';
  m[45]:='FST m32';
  m[46]:='FSTP m32';
  m[47]:='FSTCW m16';
  m[48]:='FSTENV m';
  m[49]:='FTST';
  m[50]:='FXAM';
  m[51]:='FXCH st(i)';
  m[52]:='FXTRACT';
  m[53]:='FYL2X';
  m[54]:='FYL2XP1';
  {_$da}
  m[55]:='FCMOVB st(0),st(i)';
  m[56]:='FCMOVE st(0),st(i)';
  m[57]:='FCMOVBE st(0),st(i)';
  m[58]:='FVMOVU st(0),st(i)';
  m[59]:='FIADD m32';
  m[60]:='FICOM m32';
  m[61]:='FICOMP m32';
  m[62]:='FIDIV m32';
  m[63]:='FIDIVR m32';
  m[64]:='FIMUL m32';
  m[65]:='FISUB m32';
  m[66]:='FISUBR m32';
  m[67]:='FUCOMPP';
  {_$db}
  m[68]:='FCLEX';
  m[69]:='FCMOVNB st(0),st(i)';
  m[70]:='FCMOVNE st(0),st(i)';
  m[71]:='FCMOVNBE st(0),st(i)';
  m[72]:='FVMOVNU st(0),st(i)';
  m[73]:='FCOMI st(0),st(i)';
  m[74]:='FDISI';
  m[75]:='FENI';
  m[76]:='FILD m32';
  m[77]:='FINIT';
  m[78]:='FIST m32';
  m[79]:='FISTP m32';
  m[80]:='FLD m80';
  m[81]:='FNCLEX';
  m[82]:='FNDISI';
  m[83]:='FNENI';
  m[84]:='FNINIT';
  m[85]:='FNSETPM';
  m[86]:='FSETPM';
  m[87]:='FSTP m80';
  m[88]:='FUCOMI st(0),st(i)';
  {_$dc}
  m[89]:='FADD m64';
  m[90]:='FADD st(i),st(0)';
  m[91]:='FCOM m64';
  m[92]:='FCOMP m64';
  m[93]:='FDIV m64';
  m[94]:='FDIV st(i),st(0)';
  m[95]:='FDIVR m64';
  m[96]:='FDIVR st(i),st(0)';
  m[97]:='FMUL m64';
  m[98]:='FMUL st(i),st(0)';
  m[99]:='FSUB m64';
  m[100]:='FSUB st(i),st(0)';
  m[101]:='FSUBR m64';
  m[102]:='FSUBR st(i),st(0)';
  {_$dd}
  m[103]:='FFREE st(i)';
  m[104]:='FLD m64';
  m[105]:='FNSAVE m';
  m[106]:='FNSTSW m16';
  m[107]:='FRSTOR m';
  m[108]:='FSAVE m';
  m[109]:='FST m64';
  m[110]:='FST st(i)';
  m[111]:='FSTP m64';
  m[112]:='FSTP st(i)';
  m[113]:='FSTSW m16';
  m[114]:='FUCOM st(i)';
  m[115]:='FUCOMP st(i)';
  {_$de}
  m[116]:='FADDP st(i),st(0)';
  m[117]:='FCOMPP';
  m[118]:='FDIVP st(i),st(0)';
  m[119]:='FDIVRP st(i),st(0)';
  m[120]:='FIADD m16';
  m[121]:='FICOM m16';
  m[122]:='FICOMP m16';
  m[123]:='FIDIV m16';
  m[124]:='FIDIVR m16';
  m[125]:='FIMUL m16';
  m[126]:='FISUB m16';
  m[127]:='FISUBR m16';
  m[128]:='FMULP st(i),st(0)';
  m[129]:='FSUBP st(i),st(0)';
  m[130]:='FSUBRP st(i),st(0)';
  {_$df}
  m[131]:='FBLD m80';
  m[132]:='FBSTP m80';
  m[133]:='FCOMIP st(0),st(i)';
  m[134]:='FILD m16';
  m[135]:='FIST m16';
  m[136]:='FISTP m16';
  m[137]:='FNSTSW AX';
  m[138]:='FSTSW AX';
  m[139]:='FUCOMIP st(0),st(i)';
  {_$9b}
  m[140]:='FWAIT';
  {_$0f}
  m[141]:='FXSTOR m';
  m[142]:='FXSAVE m';
  {-------}
  if paramCount <> 2 then
  begin
    writeln(#13#10'DisAsm  by  arT(c)  v0.0.2  ironWoodcutter@bk.ru'#13#10+
            'Usage:   <soursefile.bin> <destinationfile.asm>'#13#10+
            'Example: code.obj  code.asm');
    halt;
  end;
  assign(f, paramStr(1));
  {$I-} reset(f, 1); {$I+}
  if IOresult <> 0 then
  begin
     writeln('Error: file  <'+ParamStr(1)+'>  not found');
     halt;
  end;
  blockRead(f, buf, SizeOf(buf), size);
  close(f);
  write('process... ');
  {-- ᥬ஢ --}
  assign(f, paramStr(2));
  rewrite(f, 1);
  ip := 0;                         { 砫 }
  repeat
    ofs := ip;                     {  砫 }
    disAsm;                        {ॢ  -}
    str := #9+str;
    for i := ip-1 downto ofs do    {   ⮩ }
      str := hexByte(buf[i]) + str;
    str := hexWord(ofs)+': ' + str+#13#10; {⠢  }
    blockWrite(f, str[1], length(str), i); {  "⥪⮢" 䠩}
  until ip >= size;               {ᥬ஢,   諨  }
  close(f);
  writeln('completed');
end.
